(******************************************************************************
 * AcAssist                                                                   *
 *                                                                            *
 * Sabato, 01/08/1998                                                         *
 *         La propriet "DialogText"  diventata una TStringList per avere    *
 *         la possibilit di avere testi su pi linee.                        *
 * Domenica, 02/08/1998                                                       *
 *         E' stato aggiunto l'evento on click per quando si clicca nella     *
 *         finestra dell'assistente.                                          *
 * Venerd, 05/03/2004                                                        *
 *         Quando mostra una dialog box, se                                   *
 *           La scheda si trova sotto la meta dello schermo, cerca di mettere *
 *           la dialog box inzialmente sopra e viceversa.                     *
 *           (Per fare in modo che sia piu' centrata rispetto allo schermo)   *
 *                                                                            *
 ******************************************************************************)
unit AcAssist;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface
(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ACDialogEngine, StdCtrls;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACDialogStyle = (TACDS_Si_No_Annulla,
                    TACDS_Ok,
                    TACDS_Error,
                    TACDS_Si_No);
  TACAssist = class(TComponent)
  private
    { Private declarations }
    Scheda   : TForm; // E' il form con l'immagine
    Immagine : TPicture;
    Frm      : TForm; // Form del fumetto (dialog bog)
    F_DialogTitle : String;
    F_DialogText  : TStringList;
    F_Dialog_Style : TACDialogStyle;
    F_OnClick      : TNotifyEvent;

  protected
    { Protected declarations }
    constructor Create(AOwner: TComponent); Override;
    Destructor Destroy;Override;
    function Get_Form_Visible : Boolean;
    procedure Set_Form_Visible(fl:Boolean);
    procedure Set_Immagine(img:TPicture);
    procedure Form_Paint(Sender: TObject);
    procedure On_Exit_form(Sender: TObject);
    procedure Riposiziona_controlli(Ctr:TACDialogEngine;
                                    Old_Style, New_Style : ACDEPosition );
    function Value_position_vert(Pos:ACDEPosition):Integer;
    function Value_position_ori(Pos:ACDEPosition):Integer;
    function Get_Left : Integer;
    procedure Set_Left(X:Integer);
    function Get_Top: Integer;
    procedure Set_Top(X:Integer);
    function Get_Height : Integer;
    procedure Set_Height(X:Integer);
    function Get_Width: Integer;
    procedure Set_Width(X:Integer);
    procedure Set_DialogText(Txt:TStringList);
    procedure Insert_Caption_String_List(Lbl:TLabel;Txt:TStringList);
    procedure OnClickForm(Sender:TObject);
    Procedure Posiziona_Scheda(Ctr:TACDialogEngine);
    function  Value_Per_Dimensione(Pos:ACDEPosition):Integer;
    procedure Sposta_V(Ctr:TACDialogEngine;Delta:Integer);
    procedure Sposta_O(Ctr:TACDialogEngine;Delta:Integer);
  public
    { Public declarations }
    procedure Show_Dialog(Ctr:TACDialogEngine);
    function Show_Modal_Dialog(Ctr:TACDialogEngine):TModalResult;
    function Show_Dialog_Box:TModalResult;
  published
    { Published declarations }
    property Visible : Boolean Read Get_Form_Visible Write Set_Form_Visible;
    property Picture : TPicture Read Immagine Write Set_Immagine;
    property Left    : Integer Read Get_Left Write Set_Left;
    property Top     : Integer Read Get_Top Write Set_Top;
    Property DialogTitle : String Read F_DialogTitle Write F_DialogTitle;
    Property DialogText  : TStringList Read F_DialogText Write Set_DialogText;
    property DialogStyle : TACDialogStyle Read F_Dialog_Style Write F_Dialog_Style;
    Property Height      : Integer Read Get_Height Write Set_Height;
    Property Width       : Integer Read Get_Width Write Set_Width;
    Property OnClick     : TNotifyEvent Read F_OnClick Write F_OnClick;


  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses ACFormDialog_Si_No_Annulla, AcFormDialog_Ok, ACFormDialog_Error,
     ACFormDialog_Si_No;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
 constructor TACassist.Create(AOwner: TComponent);
begin
  Inherited;
  Scheda := TForm.Create(Self);
  F_DialogText := TStringList.Create;
  With scheda do
  begin
    BorderStyle := bsToolWindow;
    OnPaint     := Form_Paint;
    FormStyle   := fsStayOnTop;
    Height      := 10;
    Width       := 10;
    OnClick     := OnClickForm;

  end;
  Immagine := TPicture.Create;
  OnClick := Nil;

//  Immagine.Parent := Self;
end;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
Destructor TACassist.Destroy;
begin
  Scheda.Free;
  Immagine.Free;
  F_DialogText.Free;
  Inherited;

end;

(******************************************************************************
 * Get_Form_Visible                                                           *
 ******************************************************************************)
function TACassist.Get_Form_Visible : Boolean;
begin
  Get_Form_Visible := Scheda.visible;
end;

(******************************************************************************
 * Set_Form_Visible                                                           *
 ******************************************************************************)
procedure TACassist.Set_Form_Visible(fl:Boolean);
begin
  if (Scheda.visible <> fl) then
     Scheda.visible := fl;
end;

(******************************************************************************
 * Set_Immagine                                                               *
 ******************************************************************************)
procedure TACassist.Set_Immagine(img:TPicture);
Begin
  Immagine.Assign(Img);
End;


(******************************************************************************
 * Form_Paint                                                                 *
 ******************************************************************************)
procedure TACAssist.Form_Paint(Sender: TObject);
Var dy,dx : Integer;
begin
  with Picture.BitMap.Canvas.ClipRect do
  begin
    Dx := -Scheda.ClientWidth+Scheda.Width;
    Dy := -Scheda.ClientHeight+Scheda.Height;
    Scheda.Width := dx+Right-Left;
    Scheda.Height := dy+Bottom-Top;
  End;
  Scheda.Canvas.CopyRect(Picture.BitMap.Canvas.ClipRect,
                         Picture.BitMap.Canvas,
                         Picture.BitMap.Canvas.ClipRect);
end;

(******************************************************************************
 * On_Exit_form                                                               *
 ******************************************************************************)
procedure TACAssist.On_Exit_form(Sender: TObject);
begin
  frm.hide;
end;

(******************************************************************************
 * Posiziona_Scheda                                                           *
 ******************************************************************************)
Procedure TACAssist.Posiziona_Scheda(Ctr:TACDialogEngine);
Const DELTA = 20;
Var
    l1,               // Larghezza Form
    h1,               // Altezza Form
    ls,               // Larghezza schermo
    hs     : Integer; // Altezza schermo
    Old_Style : ACDEPosition;

Begin

  Old_Style := Ctr.Style;

  l1 := Frm.Width;
  h1 := Frm.Height;
  ls := Screen.Width;
  hs := Screen.height;


  if (Scheda.top<Screen.Height div 2) then
  begin
    Ctr.Style := ACDETopLeft;

    Frm.Left := Scheda.Left+Scheda.Width-30;
    Frm.Top  := Scheda.Top+Scheda.Height-20;

    if (Scheda.Top+Scheda.Height-DELTA+Frm.Height>Hs) then // Se il form non ci sta lo sposta in verticale
    begin
      Ctr.Style := ACDEBottomLeft;
      Frm.Top   := Scheda.Top-h1+30;
    end;
    if (Scheda.Left+Scheda.Width-DELTA+Frm.Width>Ls) then // se il form non ci sta lo sposta dall'altra parte
    begin
      //if (Ctr.Style = ACDEBottomLeft) then Ctr.Style := ACDEBottomRight
      //Else Ctr.Style := ACDETopRight;
      Ctr.Style := ACDETopRight;
      Frm.Left   := Scheda.Left-L1+40;
    end;

  end
  else
  begin
    Ctr.Style := ACDEBottomLeft;

    Frm.Left := Scheda.Left+Scheda.Width-30;
    Frm.Top  := Scheda.Top-FRM.Height+DELTA;

    if (Frm.Top+Frm.Height-Scheda.Top<20) then // sposta in verticale se  troppo siora
    begin
      Ctr.Style := ACDETopLeft;
      //Frm.Top   := Scheda.Top+Scheda.Height-DELTA;
    end;

    if (Scheda.Left+Scheda.Width-DELTA+Frm.Width>Ls) then // se il form non ci sta lo sposta dall'altra parte
    begin
      //if (Ctr.Style = ACDEBottomLeft) then Ctr.Style := ACDEBottomRight
      //Else Ctr.Style := ACDETopRight;
      Ctr.Style := ACDEBottomRight;
      Frm.Left   := Scheda.Left-L1+40;
    end;

  end;



  Riposiziona_controlli(Ctr,old_Style,Ctr.Style);

  if(Frm.Top<0) then
  begin
    Scheda.Top := Scheda.Top-Frm.Top;
    Frm.Top    := 0;
  end;

End;
(******************************************************************************
 * Show_Dialog                                                                *
 ******************************************************************************)
procedure TACAssist.Show_Dialog(Ctr:TACDialogEngine);
begin
  if(Not Scheda.visible) then
  begin
    Scheda.BringToFront;
    Scheda.Show;
  end;
  SetWindowPos(scheda.Handle,
               HWND_TOPMOST,
               scheda.left,
               scheda.top,
               scheda.width,
               scheda.height,
               SWP_NOACTIVATE);
  Frm := TForm(Ctr.Owner);
//  x1 := Frm.Left;
//  y1 := Frm.Top;

//  Frm.Left := Scheda.Left+Scheda.Width-30;
//  Frm.Top  := Scheda.Top+Scheda.Height-20;
  Ctr.OnExit := On_Exit_form;
  Frm.OnDeactivate := On_Exit_form;

  Posiziona_Scheda(Ctr);
  Frm.Show;

end;
(******************************************************************************
 * Show_Modal_Dialog                                                          *
 ******************************************************************************)
function TACAssist.Show_Modal_Dialog(Ctr:TACDialogEngine):TModalResult;
Var
    Ris       : TModalResult;
begin
  if(Not Scheda.visible) then
  begin
    Scheda.BringToFront;
    Scheda.Show;
  end;
  SetWindowPos(scheda.Handle,
               HWND_TOPMOST,
               scheda.left,
               scheda.top,
               scheda.width,
               scheda.height,
               SWP_NOACTIVATE);
  Frm := TForm(Ctr.Owner);
//  x1 := Frm.Left;
//  y1 := Frm.Top;


  Frm.Left := Scheda.Left+Scheda.Width-30;
  Frm.Top  := Scheda.Top+Scheda.Height-20;
  Ctr.OnExit := On_Exit_form;
  Frm.OnDeactivate := Nil;

  Posiziona_Scheda(Ctr);

  Ris := Frm.ShowModal;
  Show_Modal_Dialog := ris;


end;

(******************************************************************************
 * Value_position_ver                                                         *
 *                                                                            *
 * La posizione in alto vale: -1                                              *
 * La posizione in basso vale: 1                                              *
 * Le altre valgono: 0                                                        *
 ******************************************************************************)
function TACAssist.Value_position_vert(Pos:ACDEPosition):Integer;
Var v : Integer;
begin
 v := 0;
 if(pos in [ACDETopLeft,ACDETopRight,ACDETopCenter]) Then v:=-1;
 if(pos in [ACDEBottomLeft,ACDEBottomRight,ACDEBottomCenter]) Then v:=1;
 Value_position_vert := v;
end;

(******************************************************************************
 * Value_position_Ori                                                         *
 *                                                                            *
 * La posizione a sinistra vale: -1                                           *
 * La posizione a destra vale: 1                                              *
 * Le altre valgono: 0                                                        *
 ******************************************************************************)
function TACAssist.Value_position_ori(Pos:ACDEPosition):Integer;
Var v : Integer;
begin
 v := 0;
 if(pos in [ACDELeftTop,ACDELeftBottom]) Then v:=-1;
 if(pos in [ACDERightTop,ACDERightBottom]) Then v:=1;
 Value_position_Ori := v;
end;
(******************************************************************************
 * Value_Per_Dimensione                                                       *
 *                                                                            *
 ******************************************************************************)
function TACAssist.Value_Per_Dimensione(Pos:ACDEPosition):Integer;
Var v : Integer;
Begin
  v := 0;
  if(pos in [ACDELeftTop,ACDELeftBottom]) Then v:=1;
  if(pos in [ACDERightTop,ACDERightBottom]) Then v:=2;
  if(pos in [ACDETopLeft,ACDETopRight]) Then v:=3;
  if(pos in [ACDEBottomLeft,ACDEBottomRight]) Then v:=4;
  Value_Per_Dimensione := V;
End;
(******************************************************************************
 * Sposta_V                                                                   *
 ******************************************************************************)
procedure TACAssist.Sposta_V(Ctr:TACDialogEngine;Delta:Integer);
Var C1 : Integer;
begin
  for c1 := 0 to ctr.ControlCount-1 do
  begin
    ctr.Controls[c1].Top := ctr.Controls[c1].Top+Delta;
  end;
end;
(******************************************************************************
 * Sposta_O                                                                   *
 ******************************************************************************)
procedure TACAssist.Sposta_O(Ctr:TACDialogEngine;Delta:Integer);
Var C1 : Integer;
begin
  for c1 := 0 to ctr.ControlCount-1 do
  begin
    ctr.Controls[c1].Left := ctr.Controls[c1].Left+Delta;
  end;
end;

(******************************************************************************
 * Riposiziona_Controlli                                                      *
 ******************************************************************************)
procedure TACAssist.Riposiziona_controlli(Ctr:TACDialogEngine;
                                          Old_Style, New_Style : ACDEPosition );
Var pos_1, pos_2 : Integer;
begin

  pos_1 := Value_position_vert(Old_Style);
  pos_2 := Value_position_vert(New_Style);
(********** Se passa da sopra a sotto alzo i componenti **********)
  if(Pos_1<Pos_2) then Sposta_V(Ctr,-20);

(********** Se passa da sotto a sopra abbasso i componenti **********)
  if(Pos_1>Pos_2) then Sposta_V(Ctr,20);


  pos_1 := Value_position_ori(Old_Style);
  pos_2 := Value_position_ori(New_Style);
(********** Se passa da sopra a sotto alzo i componenti **********)
  if(Pos_1<Pos_2) then Sposta_O(Ctr,-20);

(********** Se passa da sotto a sopra abbasso i componenti **********)
  if(Pos_1>Pos_2) then Sposta_V(Ctr,20);

//  if(old_pos}
end;

(******************************************************************************
 * Get_Left                                                                   *
 ******************************************************************************)
function TACAssist.Get_Left : Integer;
begin
  Get_Left := Scheda.Left;
end;
(******************************************************************************
 * Set_Left                                                                   *
 ******************************************************************************)
procedure TACAssist.Set_Left(X:Integer);
begin
  Scheda.Left:=x;
end;
(******************************************************************************
 * Get_Top                                                                    *
 ******************************************************************************)
function TACAssist.Get_Top: Integer;
begin
  Get_Top := Scheda.Top;
end;
(******************************************************************************
 * Set_Top                                                                    *
 ******************************************************************************)
procedure TACAssist.Set_Top(X:Integer);
begin
  Scheda.Top := x;
end;

(******************************************************************************
 * Insert_Caption_String_List                                                 *
 ******************************************************************************)
procedure TACAssist.Insert_Caption_String_List(Lbl:TLabel;Txt:TStringList);
Var Cnt1 : Integer;
begin
  Lbl.Caption := '';
  For Cnt1 := 0 to Txt.Count-1 do
  begin
    Lbl.Caption:=Lbl.Caption+Txt.Strings[Cnt1];
    if(Cnt1<Txt.Count-1) then Lbl.Caption := Lbl.Caption +#13;
  end;

end;
(******************************************************************************
 * Show_Dialog_Box                                                            *
 ******************************************************************************)
function TACAssist.Show_Dialog_Box:TModalResult;
Const TOP_LABEL       = 13;
      MARGINE         = 5;
      DELTA_BEVEL_BTN = 8;
      DELTA_BTN_FORM  = 40;

Var

  Frm1 : TFormDialog_Si_No_Annulla;
  Frm2 : TFormDialog_Ok;
  Frm3 : TFormDialog_Error;
  Frm4 : TFormDialog_Si_No;
  Ris  : TModalResult;
begin
  SetWindowPos(scheda.Handle,
               HWND_TOPMOST,
               scheda.left,
               scheda.top,
               scheda.width,
               scheda.height,
               SWP_NOACTIVATE);

  Ris := mrCancel;
  if (DialogStyle=TACDS_Si_No_Annulla) then
  begin
    Frm1:=TFormDialog_Si_No_Annulla.Create(Self);
  //  Application.CreateForm(TFormDialog_Si_No_Annulla, Frm1);
    Frm1.D_Titolo.Caption:=DialogTitle;
    Insert_Caption_String_List(Frm1.D_Testo,DialogText);
    Frm1.Panel1.Height   := Frm1.D_Testo.Height + TOP_LABEL + MARGINE;
    Frm1.Bevel1.Top      := Frm1.Panel1.Top + Frm1.Panel1.Height + MARGINE;
    Frm1.BtnSi.Top       := Frm1.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm1.BtnNo.Top       := Frm1.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm1.BtnAnnulla.Top  := Frm1.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm1.Height          := Frm1.BtnSi.Top  + DELTA_BTN_FORM;


    Ris:=Show_Modal_Dialog(Frm1.ACDialogEngine1);
    Frm1.Free;
//        Bevel1: TBevel;
//    BtnSi: TACButton;
  End;
  if (DialogStyle=TACDS_Si_No) then
  begin
    Frm4:=TFormDialog_Si_No.Create(Self);
  //  Application.CreateForm(TFormDialog_Si_No_Annulla, Frm1);
    Frm4.D_Titolo.Caption:=DialogTitle;
    Insert_Caption_String_List(Frm4.D_Testo,DialogText);
    Frm4.Panel1.Height   := Frm4.D_Testo.Height + TOP_LABEL + MARGINE;
    Frm4.Bevel1.Top      := Frm4.Panel1.Top + Frm4.Panel1.Height + MARGINE;
    Frm4.BtnSi.Top       := Frm4.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm4.BtnNo.Top       := Frm4.Bevel1.Top + DELTA_BEVEL_BTN;
//  Frm4.BtnAnnulla.Top  := Frm1.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm4.Height          := Frm4.BtnSi.Top  + DELTA_BTN_FORM;

    Ris:=Show_Modal_Dialog(Frm4.ACDialogEngine1);
    Frm4.Close;
    Frm4.Free;
  End;

  if (DialogStyle=TACDS_Ok) then
  begin
    Frm2:=TFormDialog_Ok.Create(Self);
  //  Application.CreateForm(TFormDialog_Si_No_Annulla, Frm1);
    Frm2.D_Titolo.Caption:=DialogTitle;
    Insert_Caption_String_List(Frm2.D_Testo,DialogText);
    Frm2.Panel1.Height   := Frm2.D_Testo.Height + TOP_LABEL + MARGINE;
    Frm2.Bevel1.Top      := Frm2.Panel1.Top + Frm2.Panel1.Height + MARGINE;
    Frm2.BtnSi.Top       := Frm2.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm2.Height          := Frm2.BtnSi.Top  + DELTA_BTN_FORM;
    Ris:=Show_Modal_Dialog(Frm2.ACDialogEngine1);
    Frm2.Free;
  End;
  if (DialogStyle=TACDS_Error) then
  begin
    Frm3:=TFormDialog_Error.Create(Self);
  //  Application.CreateForm(TFormDialog_Si_No_Annulla, Frm1);
    Frm3.D_Titolo.Caption:=DialogTitle;
    Insert_Caption_String_List(Frm3.D_Testo,DialogText);
    Frm3.Panel1.Height   := Frm3.D_Testo.Height + TOP_LABEL + MARGINE;
    Frm3.Bevel1.Top      := Frm3.Panel1.Top + Frm3.Panel1.Height + MARGINE;
    Frm3.BtnSi.Top       := Frm3.Bevel1.Top + DELTA_BEVEL_BTN;
    Frm3.Height          := Frm3.BtnSi.Top  + DELTA_BTN_FORM;

    Ris:=Show_Modal_Dialog(Frm3.ACDialogEngine1);
    Frm3.Free;
  End;

  Show_Dialog_Box := Ris;
end;
(******************************************************************************
 * Get_Height                                                                 *
 ******************************************************************************)
function TACAssist.Get_Height : Integer;
begin
  Get_Height := Scheda.Height;
end;
(******************************************************************************
 * Set_Height                                                                 *
 ******************************************************************************)
procedure TACAssist.Set_Height(X:Integer);
begin
  Scheda.Height:=x;
end;
(******************************************************************************
 * Get_Width                                                                  *
 ******************************************************************************)
function TACAssist.Get_Width : Integer;
begin
  Get_Width := Scheda.Width;
end;
(******************************************************************************
 * Set_Width                                                                  *
 ******************************************************************************)
procedure TACAssist.Set_Width(X:Integer);
begin
  Scheda.Width:=x;
end;

(******************************************************************************
 * Set_DialogText                                                             *
 ******************************************************************************)
procedure TACAssist.Set_DialogText(Txt:TStringList);
begin
 F_DialogText.Assign(txt);
end;

(******************************************************************************
 * OnClickForm                                                                *
 ******************************************************************************)
procedure TACAssist.OnClickForm(Sender:TObject);
begin
  If (Assigned(OnClick)) then OnClick(Sender);
end;
end.

