(******************************************************************************
 * ACFunzioni Grafiche                                                        *
 *                                                                            *
 * Data        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * 29/12/2003  Aggiuta funzione "ACProc_Sfumatura1                            *
 ******************************************************************************)
unit acfunzioni_grafiche;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses Graphics, Windows;

Procedure ACProc_Sfumatura1(Color_Start,Color_End:Integer;Canvas:TCanvas;Rect:TRect;Stile:Integer);

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * ACProc_Sfumatura1                                                          *
 *                                                                            *
 * Crea una Sfumatura                                                         *
 *                                                                            *
 * Nome         Descrizione                                                   *
 * ------------ ------------------------------------------------------------- *
 * Color_Start  Colore di partenza della sfumatura                            *
 * Color_End    Colore con cui termina la sfumatura                           *
 * Canvas       Canvas a cui applicare la sfumatura                           *
 * Rect         Rect Area a cui applicare la sfumatura                        *
 * Stile        0: Orizzontale                                                *
 *              1: Verticale                                                  *
 ******************************************************************************)
Procedure ACProc_Sfumatura1(Color_Start,Color_End:Integer;Canvas:TCanvas;Rect:TRect;Stile:Integer);
Var
    r1,
    g1,
    b1    : Integer;
    r2,
    g2,
    b2    : Integer;
    r3,
    g3,
    b3    : Integer;
    c1,
    c2    : Integer;
    lar   : Integer;
    cnt   : Integer;

Begin
  with Canvas do
  begin
    c2                 := ColorToRGB(Color_Start);
    c1                 := ColorToRGB(Color_End);
    r1                 := c1 and $ff;
    g1                 := (c1 and $ff00) div $100;
    b1                 := (c1 and $ff0000) div $10000;
    r2                 := c2 and $ff;
    g2                 := (c2 and $ff00) div $100;
    b2                 := (c2 and $ff0000) div $10000;

    if (Stile=0) then
    begin
      lar := Rect.Right-Rect.Left;
      for cnt := 0 to lar do
      begin
        r3 := Round((r1 * cnt / lar) + (r2 * (lar-cnt) / lar));
        g3 := Round((g1 * cnt / lar) + (g2 * (lar-cnt) / lar));
        b3 := Round((b1 * cnt / lar) + (b2 * (lar-cnt) / lar));
        Canvas.Pen.Color := rgb(r3,g3,b3);
        Canvas.MoveTo(cnt,rect.Top);
        Canvas.LineTo(cnt,Rect.Bottom);
      End;
    end
    else
    begin
      lar := Rect.Bottom-Rect.top;
      for cnt := 0 to lar do
      begin
        r3 := Round((r1 * cnt / lar) + (r2 * (lar-cnt) / lar));
        g3 := Round((g1 * cnt / lar) + (g2 * (lar-cnt) / lar));
        b3 := Round((b1 * cnt / lar) + (b2 * (lar-cnt) / lar));
        Canvas.Pen.Color := rgb(r3,g3,b3);
        Canvas.MoveTo(rect.left,cnt);
        Canvas.LineTo(Rect.right,cnt);
      End;

    end;
  end;
End;



end.
