(******************************************************************************
 * AcDbEdit                                                                   *
 ******************************************************************************)
unit AcDbEdit;
{$i AcDefinizioni.pas }
(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACDbf, AcDbLabel
{$IFDEF DELPHI2}
   ,DsgnIntf
{$ENDIF}
{$IFDEF DELPHI6}
   ,DesignIntf,DesignEditors
{$ENDIF};


(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACDBEdit = class(TEdit)
  private
    { Private declarations }
     Comp_TACDbf : TACDbf;
     Campo       : String;
  protected
    { Protected declarations }
    procedure Set_TACDbf(V:TACDbf);

  public
    { Public declarations }
    procedure Legge_Field;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    { Published declarations }
    property FieldSource : TACDbf Read Comp_TACDbf Write Set_TACDbf;
    property FieldName   : String read Campo Write Campo;
  end;

(******************************************************************************
 * TAcValueDbFieldList                                                        *
 ******************************************************************************)
type TAcValueDbFieldList = Class(TStringProperty)
 public
   function GetAttributes : TPropertyAttributes; override;
   procedure GetValues(Proc: TGetStrProc);override;
 end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACDBEdit.Create(AOwner: TComponent);
Begin
  Inherited;
  Comp_TACDbf:=TACDbf.Create(Self);
End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACDBEdit.Destroy;
Begin
  if (Comp_TACDbf<>Nil) then Comp_TACDbf.Remove_Control(Legge_Field);
//  Comp_TACDbf.Free;
  Inherited;
End;

(******************************************************************************
 * Set_TACDBF                                                                 *
 ******************************************************************************)
procedure TACDBEdit.Set_TACDbf(V:TACDbf);
Begin
  if (Comp_TACDbf<>nil) then
  begin
    if(Comp_TACDbf<>v) then Comp_TACDbf.Remove_Control(Legge_Field);
  end;
//  Comp_TACDbf.Assign(v);
  comp_TACDBF := v;
  Comp_TACDbf.Add_control(Legge_Field);
End;

(******************************************************************************
 * GetAttributes                                                              *
 ******************************************************************************)
function TAcValueDbFieldList.GetAttributes : TPropertyAttributes;
begin
  Result:=inherited GetAttributes+[paValueList, paMultiSelect];
end;

(******************************************************************************
 * Edit                                                                       *
 ******************************************************************************)
//procedure TAcKeyEditProperty.Edit;
procedure TAcValueDbFieldList.GetValues(Proc: TGetStrProc);
Var
    c1      : Integer;
    Source  : TACDbf;
begin
  Source := Nil;
  if GetComponent(0).ClassType = TACDbLabel then
     Source := (GetComponent(0) as TACDbLabel).FieldSource;
  if GetComponent(0).ClassType = TACDbEdit then
     Source := (GetComponent(0) as TACDbEdit).FieldSource;

  try
    if (Source<>nil) then
    Begin
      for c1 := 0 to Source.FieldName.count-1 do
        proc(Source.FieldName.Strings[c1]);
    End;
  finally
  end;
end;


(******************************************************************************
 * Legge_Field                                                                *
 ******************************************************************************)
procedure TACDBEdit.Legge_Field;
Begin
  if (FieldSource<>nil) then
  Begin
    if (FieldName<>'') then
    begin
      Caption := FieldSource.Get_Field_Str(FieldName);
    end;
  End;
End;


end.
