(******************************************************************************
 * AcLed01                                                                    *
 ******************************************************************************)
unit AcLed01;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
Uses Controls, Classes, Graphics, Windows, AcProcDeclare;
(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACLedStyle = (lsDiamond,lsRectangle);
  TAcLed01 = class(TGraphicControl)
  private
    { Private declarations }
    fbrush_1  : TBrush;
    fbrush_2  : TBrush;
    fbrush_3  : TBrush;

    fstyle     : TACLedStyle;
    fStato     : Integer;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
    procedure Paint; Override;
    Procedure ReDisegna(Sender:TObject);
    procedure Set_Brush(Index:Integer;b:TBrush);
    procedure Set_Style(s:TACLedStyle);
    procedure Set_Stato(x:Integer);
  published
    { Published declarations }
    property Brush_St1  : TBrush Index 0 Read fbrush_1 Write Set_Brush;
    property Brush_St2  : TBrush Index 1 Read fbrush_2 Write Set_Brush;
    property Brush_St3  : TBrush Index 2 Read fbrush_3 Write Set_Brush;
    Property State      : Integer Read fStato Write Set_Stato;
    property Style      : TACLedStyle Read fstyle write Set_Style;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
Uses AcVarie;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TAcLed01.Create(AOwner: TComponent);
Begin
  Inherited;
  fbrush_1       := TBrush.Create;
  fBrush_1.Color := clGreen;
  fbrush_2       := TBrush.Create;
  fBrush_2.Color := clYellow;
  fbrush_3       := TBrush.Create;
  fBrush_3.Color := clRed;
  State               := 1;
  Height              := 32;
  Width               := 32;
  fBrush_1.OnChange   := ReDisegna;
  fBrush_2.OnChange   := ReDisegna;
  fBrush_3.OnChange   := ReDisegna;
End;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TAcLed01.Paint;
Var Dim,cx,cy : Integer;
Begin
  inherited;
  if (Height<10) Then Height := 10;
  if (Width<10) Then Width:= 10;
//********** Diamond **********
  if (Style=lsDiamond) Then
  Begin
    if (Width<Height) Then dim := Width div 2
    Else dim := Height div 2;
    cx := Width div 2;
    cy := Height div 2;
    case State of
     1: Canvas.Brush.Assign(Brush_St1);
     2: Canvas.Brush.Assign(Brush_St2);
     else Canvas.Brush.Assign(Brush_St3);
    End;

    Canvas.Polygon([Point(cx-1,cy-dim-1),
                    Point(cx-1-dim,cy-1),
                    Point(cx-1,cy+dim-1),
                    Point(cx-1+dim,cy-1),
                    Point(cx-1,cy-dim-1)]);
    Canvas.Pen.Color :=clWhite;
    Canvas.MoveTo(cx-1,cy-dim-1);
    Canvas.LineTo(cx-dim-1,cy-1);
    Canvas.Pen.Color :=clGray;
    Canvas.LineTo(cx-1,cy+dim-1);
    Canvas.Pen.Color :=clBlack;
    Canvas.LineTo(cx+dim-1,cy-1);
    Canvas.Pen.Color :=clGray;
    Canvas.LineTo(cx-1,cy-dim-1);
  End;
//********** Rectangle **********
  if (Style=lsRectangle) Then
  Begin
    case State of
     1: Canvas.Brush.Assign(Brush_St1);
     2: Canvas.Brush.Assign(Brush_St2);
     else Canvas.Brush.Assign(Brush_St3);
    End;
    Canvas.Polygon([Point(0,0),
                    Point(Width-1,0),
                    Point(Width-1,Height-1),
                    Point(0,Height-1)]);

    Ac_Rettangolo(Canvas,Rect(ClientRect.Left,
                          ClientRect.Top,
                          ClientRect.Right-1,
                          ClientRect.Bottom-1),clGray,clWhite);
    Ac_Rettangolo(Canvas,Rect(ClientRect.Left+1,
                          ClientRect.Top+1,
                          ClientRect.Right-2,
                          ClientRect.Bottom-2),clBlack,clSilver);

//    Canvas.Pen.Color := clWhite;
//    Canvas.MoveTo(3,3);
//    Canvas.LineTo(6,3);
  End
End;

(******************************************************************************
 * Set_Brush                                                                  *
 ******************************************************************************)
procedure TAcLed01.Set_Brush(Index:Integer;b:TBrush);
Begin
  case Index of
   1: fbrush_1.assign(b);
   2: fbrush_2.assign(b);
   else fbrush_3.assign(b);
  End;

//  Invalidate;
End;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TAcLed01.Destroy;
Begin
  fbrush_1.Free;
  fbrush_2.Free;
  fbrush_3.Free;
  Inherited;
End;

(******************************************************************************
 * ReDisegna                                                                  *
 ******************************************************************************)
Procedure TAcLed01.ReDisegna(Sender:TObject);
Begin
  Invalidate;
End;

(******************************************************************************
 * ReDisegna                                                                  *
 ******************************************************************************)
procedure TAcLed01.Set_Style(s:TACLedStyle);
Begin
  fstyle := s;
  Invalidate;
End;

(******************************************************************************
 * Set_Stato                                                                  *
 ******************************************************************************)
procedure TAcLed01.Set_Stato(x:Integer);
Begin
 if (x<1) Then x := 1;
 if (x>3) Then x := 3;
 fStato := x;
 Invalidate;
End;
end.
