(******************************************************************************
 * ACMoveBox                                                                  *
 ******************************************************************************)
unit ACMoveBox;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, AcProcDeclare, stdctrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACMoveBox = class( TCustomLabel)
  private
    { Private declarations }
    F_Width,
    F_Left,
    F_Top,
    F_Height : Integer;
    premuto : Boolean;
    old_x,old_y : Integer;
    Iniziato : Boolean;
    F_Box_Moved : TAC_Proc_Box_Moved;
  protected
    { Protected declarations }
    Maniglie : Array[1..8] of TShape;
    procedure disegna;
    procedure down_0(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Up_0(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure move_0(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
//    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LButtonDown;
    procedure Paint;override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property OnBoxMoved : TAC_Proc_Box_Moved Read F_Box_Moved Write F_Box_Moved;
    property Visible;
    property PopupMenu;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

//uses  unit1;

(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
const Margine_Maniglia = 2;
      Dimensione_Maniglia = Margine_Maniglia * 2;

procedure DrawDragRect (const DC: HDC; NewRect, OldRect: TRect;
  const NewSize, OldSize: TSize; const Brush: HBRUSH; BrushLast: HBRUSH);
{ Draws a dragging outline, hiding the old one if neccessary. This is
  completely flicker free, unlike the old DrawFocusRect method. In case
  you're wondering, I got a lot of ideas from the MFC sources.

  Either NewRect or OldRect can be nil or empty. }
  function CreateNullRegion: HRGN;
  var
    R: TRect;
  begin
    SetRectEmpty (R);
    Result := CreateRectRgnIndirect(R);
  end;
var
  SaveIndex: Integer;
  rgnNew, rgnOutside, rgnInside, rgnLast, rgnUpdate: HRGN;
  R: TRect;
begin
//  rgnLast := 0;
  rgnUpdate := 0;

  { First, determine the update region and select it }
  R := NewRect;
  rgnOutside := CreateRectRgnIndirect(R);
  InflateRect (R, -NewSize.cx, -NewSize.cy);
  IntersectRect (R, R, NewRect);

  rgnInside := CreateRectRgnIndirect(R);
  rgnNew := CreateNullRegion;
  CombineRgn (rgnNew, rgnOutside, rgnInside, RGN_XOR);

  if BrushLast = 0 then
    BrushLast := Brush;

  { Find difference between new region and old region }
  rgnLast := CreateNullRegion;
  with OldRect do
    SetRectRgn (rgnOutside, Left, Top, Right, Bottom);
  R := OldRect;
  InflateRect (R, -OldSize.cx, -OldSize.cy);
  IntersectRect (R, R, OldRect);
  SetRectRgn (rgnInside, R.Left, R.Top, R.Right, R.Bottom);
  CombineRgn (rgnLast, rgnOutside, rgnInside, RGN_XOR);

  { Only diff them if brushes are the same }
  if Brush = BrushLast then begin
    rgnUpdate := CreateNullRegion;
    CombineRgn (rgnUpdate, rgnLast, rgnNew, RGN_XOR);
  end;

  { Save the DC state so that the clipping region can be restored }
  SaveIndex := SaveDC(DC);
  try
    if (Brush <> BrushLast) then
    begin
      { Brushes are different -- erase old region first }
      SelectClipRgn (DC, rgnLast);
      GetClipBox (DC, R);
      SelectObject (DC, BrushLast);
      PatBlt (DC, R.Left, R.Top, R.Right-R.Left, R.Bottom-R.Top, PATINVERT);
    end;

    { Draw into the update/new region }
    if rgnUpdate <> 0 then
      SelectClipRgn (DC, rgnUpdate)
    else
      SelectClipRgn (DC, rgnNew);
    GetClipBox (DC, R);
    SelectObject (DC, Brush);
    PatBlt (DC, R.Left, R.Top, R.Right-R.Left, R.Bottom-R.Top, PATINVERT);
  finally
    { Clean up DC }
    RestoreDC (DC, SaveIndex);
  end;

  { Free regions }
  if rgnNew <> 0 then DeleteObject (rgnNew);
  if rgnOutside <> 0 then DeleteObject (rgnOutside);
  if rgnInside <> 0 then DeleteObject (rgnInside);
  if rgnLast <> 0 then DeleteObject (rgnLast);
  if rgnUpdate <> 0 then DeleteObject (rgnUpdate);
end;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACMoveBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Iniziato := False;
  ControlStyle := ControlStyle - [csOpaque] + [csAcceptsControls] ;
//  brush.style:=bsClear;
//  pen.style:=psDash;
  color := clred;
  Transparent   := True;
  premuto       := False;
  OnBoxMoved    := Nil;
  onmousedown   := down_0;
  onmouseup     := up_0;
  onmousemove   := move_0;
//  transparent:=True;



end;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACMoveBox.disegna;
Var c1     : Integer;
//    FStyle : Integer;

begin
  if(not iniziato) then
  begin
    for c1 := 1 to 8 do
    begin
//      FStyle:=GetWindowLong(Handle,GWL_STYLE);
//      FStyle:=FStyle xor WS_Caption xor WS_THICKFRAME;;
//      SetWindowLong(Handle, GWL_STYLE, FStyle);
//      SetWindowPos(Handle, HWND_TOP, left, top, width, height, SWP_DRAWFRAME);

      maniglie[c1]              := TShape.Create(Self);
//      maniglie[c1].parent       := Parent;
      maniglie[c1].brush.color  := clBlack;
      maniglie[c1].parent       := TWinControl(Self);
      maniglie[c1].BringToFront;
      maniglie[c1].Width        := Dimensione_Maniglia;
      maniglie[c1].Height       := Dimensione_Maniglia;

    end;

    Iniziato:=True;
  end;

  maniglie[1].Left   := 0;
  maniglie[1].top    := 0;
  maniglie[1].BringToFront;
  maniglie[1].cursor := crSizeNWSE;

  maniglie[2].Left   := (Width-Dimensione_Maniglia)div 2;
  maniglie[2].top    := 0;
  maniglie[2].BringToFront;
  maniglie[2].cursor := crSizeNS;

  maniglie[3].Left   := Width-Dimensione_Maniglia;
  maniglie[3].top    := 0;
  maniglie[3].BringToFront;
  maniglie[3].cursor := crSizeNESW;

  maniglie[4].Left   := 0;
  maniglie[4].top    := (Height-Dimensione_Maniglia) div 2 ;
  maniglie[4].BringToFront;
  maniglie[4].cursor := crSizeWE;

  maniglie[5].Left   := Width-Dimensione_Maniglia;
  maniglie[5].top    := (Height-Dimensione_Maniglia) div 2;
  maniglie[5].BringToFront;
  maniglie[5].cursor := crSizeWE;

  maniglie[6].Left   := 0;
  maniglie[6].top    := Height-Dimensione_Maniglia;
  maniglie[6].BringToFront;
  maniglie[6].cursor := crSizeNESW;

  maniglie[7].Left   := (Width-Dimensione_Maniglia)div 2;
  maniglie[7].top    := Height-Dimensione_Maniglia;
  maniglie[7].BringToFront;
  maniglie[7].cursor := crSizeNS;

  maniglie[8].Left   := Width-Dimensione_Maniglia;
  maniglie[8].top    := Height-Dimensione_Maniglia;
  maniglie[8].BringToFront;
  maniglie[8].cursor := crSizeNWSE;



end;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACMoveBox.Destroy;
Var c1 : Integer;
begin
  if (Iniziato) then
  begin
    for c1 := 1 to 8 do
    begin
//      maniglie[c1].Free;
    end;
  end;
  inherited;
end;


(******************************************************************************
 * Down_o                                                                     *
 ******************************************************************************)
procedure TACMoveBox.down_0(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//procedure TACMoveBox.WMLButtonDown(var Message: TWMLButtonDown);
begin
  inherited;
  premuto:=True;
//  old_x := Message.xpos;
//  old_Y := Message.ypos;
  old_x := x;
  old_Y := y;

end;


(******************************************************************************
 * up_o                                                                       *
 ******************************************************************************)
procedure TACMoveBox.Up_0(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  premuto:=False;
  if(Assigned(OnBoxMoved)) then onBoxMoved(Self);
end;

(******************************************************************************
 * Move_o                                                                     *
 ******************************************************************************)
procedure TACMoveBox.move_0(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  inherited;

  if(Premuto) then
  begin
    left := left + x - old_x;
    top  := top  + y - old_y;
//    old_x:=x;
  end;
end;

(******************************************************************************
 * Wm_Size                                                                    *
 ******************************************************************************)
procedure TACMoveBox.WMSize(var Message: TWMSize);
begin
  inherited;
//  exit;
  disegna;
//  invalidate;
end;

  function CreateHalftoneBrush: HBRUSH;
  const
    GrayPattern: array[0..7] of Word =
      ($5555, $AAAA, $5555, $AAAA, $5555, $AAAA, $5555, $AAAA);
  var
    GrayBitmap: HBITMAP;
  begin
    GrayBitmap := CreateBitmap(8, 8, 1, 1, @GrayPattern);
    Result := CreatePatternBrush(GrayBitmap);
    DeleteObject (GrayBitmap);
  end;

procedure TACMoveBox.Paint;
//Var
// NewSize, OldSize: TSize;
// Brush: HBRUSH;
// r1 : TRect;
begin
//  Brush := CreateHalftoneBrush;
//  inherited;
  if (ComponentState=[csDestroying]) then exit;

  canvas.pen.color   := clBlack;
  canvas.pen.style   := psDash;
  Canvas.Brush.Style := bsClear;
(*  canvas.MoveTo(0,0);
  canvas.LineTo(Width-1,0);

  canvas.MoveTo(Width-1,0);
  canvas.LineTo(Width-1,Height-1);

  canvas.MoveTo(Width,height-1);
  canvas.LineTo(0,Height-1);

  canvas.MoveTo(0,height-1);
  canvas.LineTo(0,0);*)
  canvas.rectangle(0,0,width,height);
(*  NewSize.cx := 10;
  NewSize.cy := 10;
  OldSize.cx := 10;
  OldSize.cy := 10;
  r1 := Rect(10,10,30,30);
  DrawDragRect (canvas.handle,
                r1,
                r1,
                NewSize,
                OldSize,
                Brush,
                Brush);
*)
//  canvas.moveto(0,0);

//  canvas.LineTo(width,height);
//  LockWindowUpdate(0);
end;


end.
