(******************************************************************************
 * AcPie                                                                      *
 ******************************************************************************)
unit AcPie;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AcGraphicControl, AcProcDeclare, QuickRep;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type

  TAcPie = class(TAcGraphicControl)
  private
    { Private declarations }
    FAlignToBand  : Boolean;
    FOnPrintEvent : TQRLabelOnPrintEvent;
//    FReport       : TQuickReport;

    FAng1 : Integer;
    FAng2 : Integer;

  protected
    { Protected declarations }

    Procedure Set_Ang(Ndx,Ang:Integer);
    procedure Paint; override;
    Function Moltiplica_per_Uno(Numero:Longint):Longint;
    Procedure Disegna(Video:Boolean;xx,yy:Integer;fnzX,fnzY:AcFunMolt;Cnv:TCanvas);
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
    procedure Print(X,Y : Integer); Override;
  published
    { Published declarations }
    property OnPrint      : TQRLabelOnPrintEvent read FOnPrintEvent Write FOnPrintEvent;
//    property ParentReport : TQuickReport read FReport write FReport;

    Property StartAngle : Integer Index 0 Read FAng1 Write Set_Ang;
    Property EndAngle   : Integer Index 1 Read FAng2 Write Set_Ang;
    Property Pen;
    Property Brush;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Set_Ang                                                                    *
 ******************************************************************************)
Procedure TAcPie.Set_Ang(Ndx,Ang:Integer);
Begin
 ang := ang mod 360;
 if (Ndx=0)and(FAng1 <> Ang) Then
 Begin
   FAng1 := Ang;
   Invalidate;
 End
 Else if (Ndx=1)and(FAng2 <> Ang) Then
 Begin
   FAng2 := Ang;
   Invalidate;
 End;
End;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
Procedure TAcPie.Disegna(Video:Boolean;xx,yy:Integer;fnzX,fnzY:AcFunMolt;Cnv:TCanvas);
Var xa,ya,xb,yb,l,h : Integer;
    A1,A2           : Single;
Begin
  if (not Visible) Then Exit;
  l := (Width) div 2;
  h := (Height) div 2;
  A1 := 3.14*StartAngle/180;
  A2 := 3.14*EndAngle/180;
  xa := l+Round(l*cos(A1));
  ya := h-Round(l*sin(A1));
  xb := l+Round(l*cos(A2));
  yb := h-Round(l*sin(A2));
  Cnv.Brush.Assign(Brush);
  Cnv.Pen.Assign(Pen);
  Cnv.Pen.Width := Pen.Width;
  Cnv.Pie(fnzX(xx+0+Pen.Width),
             fnzY(yy+0+Pen.Width),
             fnzX(xx+Width-Pen.Width),
             fnzY(yy+Height-Pen.Width),
             fnzX(xx+xa),
             fnzY(yy+ya),
             fnzX(xx+xb),
             fnzY(yy+yb));

End;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TAcPie.Paint;
Begin
  Disegna(True,0,0,Moltiplica_per_Uno,Moltiplica_per_Uno,Canvas);
//  Inherited;
End;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TAcPie.Create(AOwner : TComponent);
Begin
 Inherited;
 OnPrint      := Nil;
 ParentReport := Nil;
 Height     := 100;
 Width      := 100;
 StartAngle := 0;
 EndAngle   := 315;

End;
(******************************************************************************
 * Moltiplica_Per_Uno                                                         *
 ******************************************************************************)
Function TAcPie.Moltiplica_per_Uno(Numero:Longint):Longint;
Begin
  Moltiplica_per_Uno := Numero;
End;


(******************************************************************************
 * Print                                                                      *
 ******************************************************************************)
procedure TAcPie.Print(X,Y : Integer);
Begin
 Inherited;
 Disegna(False,Left+X,Top+Y,ParentReport.XPos,ParentReport.YPos,QRPrinter.Canvas);
End;


end.

