(******************************************************************************
 * AcQrCostumPreview                                                          *
 ******************************************************************************)
unit AcQrCostumPreview;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Quickrep, AcQrCustomPr;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TAcQrCostumPreview = class(TComponent)
  private
    { Private declarations }
    fQuick : TQuickReport;
    Frm    : TAcQrAnteprima;
    btn_testi : array[1..6] of string;
    Titolo    : String;
  protected
    { Protected declarations }
    Procedure Set_Quick(Q:TQuickReport);
    procedure Notification(AComponent: TComponent; Operation: TOperation); Override;
    function get_btn(ndx : Integer):String;
    procedure set_btn(ndx : Integer;txt : String);
    Procedure Set_Caption (txt:String);

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
  published
    { Published declarations }
    Property QuickReport : TQuickReport Read fQuick Write Set_Quick;
    Property Caption     : String Read Titolo Write Set_Caption;
    Property Btn1        : String Index 1 Read Get_Btn Write Set_Btn;
    Property Btn2        : String Index 2 Read Get_Btn Write Set_Btn;
    Property Btn3        : String Index 3 Read Get_Btn Write Set_Btn;
    Property Btn4        : String Index 4 Read Get_Btn Write Set_Btn;
    Property Btn5        : String Index 5 Read Get_Btn Write Set_Btn;
    Property Btn6        : String Index 6 Read Get_Btn Write Set_Btn;
  end;


(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TAcQrCostumPreview.Create(AOwner: TComponent);
Begin
  Frm := Nil;
  Inherited;
  if (ComponentState<>[csDesigning]) then
  begin
    Frm := TAcQrAnteprima.Create(Self);
  end;
  Btn1 := 'Pagina prec.';
  Btn2 := 'Pagina Succ.';
  Btn3 := 'Pagina intera';
  Btn4 := 'Adatta in larghezza';
  Btn5 := 'Stampa';
  Btn6 := 'Chiudi';
  Caption := 'Anteprima di stampa';

End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TAcQrCostumPreview.Destroy;
Begin
  if (ComponentState<>[csDesigning]) Then
  Begin
    fQuick := Nil;
    Frm.Free;
  End;
  Inherited;
End;

(******************************************************************************
 * Set_Quick                                                                  *
 ******************************************************************************)
Procedure TAcQrCostumPreview.Set_Quick(Q:TQuickReport);
Begin
  if (ComponentState=[csDesigning]) Then Exit;
  fQuick := q;
  Frm.Qrep := q;
End;

(******************************************************************************
 * Notification                                                               *
 ******************************************************************************)
procedure TAcQrCostumPreview.Notification(AComponent: TComponent; Operation: TOperation);
Begin
  if (ComponentState<>[csDesigning])and(AComponent.name<>'') Then
  Begin
    if (Operation=opRemove)and(AComponent=fQuick) Then
      fQuick := nil;
  End;
  inherited Notification(AComponent, Operation);
End;


(******************************************************************************
 * get_btn                                                                    *
 ******************************************************************************)
function TAcQrCostumPreview.get_btn(ndx : Integer):String;
Var Txt : String;
Begin
  Txt := btn_testi[ndx];
  get_Btn := Txt;
End;

(******************************************************************************
 * set_btn                                                                    *
 ******************************************************************************)
procedure TAcQrCostumPreview.set_btn(ndx : Integer;txt : String);
Begin
  btn_testi[ndx] := txt;
  if (ComponentState<>[csDesigning])and(Assigned(frm)) Then
  Begin
    case ndx of
      1: frm.btn1.Caption := txt;
      2: frm.btn2.Caption := txt;
      3: frm.btn3.Caption := txt;
      4: frm.btn4.Caption := txt;
      5: frm.btn5.Caption := txt;
      6: frm.btn6.Caption := txt;
    End;
  End;

End;

(******************************************************************************
 * get_btn                                                                    *
 ******************************************************************************)
Procedure TAcQrCostumPreview.Set_Caption (txt:String);
Begin
  Titolo := txt;
  if (ComponentState<>[csDesigning])and(Assigned(frm)) Then
  Begin
    frm.caption := Titolo;
  End;
End;
end.
