(******************************************************************************
 * AcFormatDialog                                                             *
 ******************************************************************************)
unit AcUnitDialog;

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

(******************************************************************************
 *  TACFormatDial                                                             *
 *                                                                            *
 ******************************************************************************)
 type
  TACUnitFunction = (acFormat);
  TACDriveName = (acDriveA,acDriveB);

  TACUnitDialog = class(TComponent)
  private
    { Private declarations }
    FCommand : TACUnitFunction;
    FDrive : TACDriveName;
  protected
    { Protected declarations }
  public
    { Public declarations }
    Function Execute:Boolean;
  published
    { Published declarations }
    property Command : TACUnitFunction Read FCommand Write FCommand;
    property Drive : TACDriveName Read FDrive Write FDrive;

  end;

 function SHFormatDrive(hWnd : HWND; Drive, fmtID, Options : Word) : Longint; stdcall;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
const  Shell32 = 'Shell32.dll';


function SHFormatDrive; external Shell32 name 'SHFormatDrive';

(******************************************************************************
 * Execute                                                                    *
 * SHFMT_ID_DEFAULT      = $FFFF;                                             *
 * SHFMT_OPT_QUICKFORMAT = $0000;                                             *
 * SHFMT_OPT_FULL        = $0001;                                             *
 * SHFMT_OPT_SYSONLY     = $0002;                                             *
 * SHFMT_ERROR           = $FFFFFFFF;                                         *
 * SHFMT_CANCEL          = $FFFFFFFE;                                         *
 * SHFMT_NOFORMAT        = $FFFFFFFD;                                         *
 * ShFormatDrive(Handle,DriveNo,SHFMT_ID_DEFAULT,SHFMT_OPT_QUICKFORMAT);      *
 *                                                                            *
 ******************************************************************************)
Function TACUnitDialog.Execute:Boolean;
var FmtRes : longint;
    DriveNo : word;
    fl      : Boolean;
begin
  fl := True;

  if (Command=AcFormat) then
  begin
    if(Drive=acDriveA) then DriveNo := 0 (* Drive A *)
    else DriveNo := 1;
    FmtRes := 0;
    try
      FmtRes:=  ShFormatDrive(Application.Handle,DriveNo,$ffff,0);
    finally
      Fl := (FmtRes >= 0);
    end;
  End;
  Execute := fl;
End;



end.
